diff -U 3 -H -d -r -N -x '*.kdev' -x '.svn*' -x 'CVS*' -- patched/libRTI/RTI1516ambassador.cpp origin/libRTI/RTI1516ambassador.cpp
--- patched/libRTI/RTI1516ambassador.cpp	2012-01-19 14:45:53.000000000 +0400
+++ origin/libRTI/RTI1516ambassador.cpp	2011-10-03 11:01:21.000000000 +0400
@@ -2381,16 +2301,15 @@
 		FederateNotExecutionMember,
 		RTIinternalError)
 	{ 
-		DEFINE_REQ_REP( M_Get_Dimension_Name );
+		M_Get_Dimension_Name req, rep ;
 
-		req->setDimension(rti1516::DimensionHandleFriend::toCertiHandle(theHandle));
-		//req->setSpace(space);
-		rep = privateRefs->executeServiceTmpl(req,rep);
+		req.setDimension(rti1516::DimensionHandleFriend::toCertiHandle(theHandle));
+		//req.setSpace(space);
+		privateRefs->executeService(&req, &rep);
 		//return hla_strdup(rep.getDimensionName());
-		std::string nameString = rep->getDimensionName();
+		std::string nameString = rep.getDimensionName();
 		std::wstring nameWString(nameString.begin(), nameString.end());
 
-		DELETE_REP();
 		return nameWString;
 	}
 
@@ -2415,12 +2334,11 @@
 		FederateNotExecutionMember,
 		RTIinternalError)
 	{ 
-		DEFINE_REQ_REP( M_Get_Attribute_Space_Handle );
+		M_Get_Attribute_Space_Handle req, rep ;
 
-		req->setAttribute(rti1516::AttributeHandleFriend::toCertiHandle(theHandle));
-		req->setObjectClass(rti1516::ObjectClassHandleFriend::toCertiHandle(theClass));
-		rep = privateRefs->executeServiceTmpl(req,rep);
-		DELETE_REP();
+		req.setAttribute(rti1516::AttributeHandleFriend::toCertiHandle(theHandle));
+		req.setObjectClass(rti1516::ObjectClassHandleFriend::toCertiHandle(theClass));
+		privateRefs->executeService(&req, &rep);
 		
 		//JRE TODO: Use space handle to to get the DimensionHandleSet?@!
 		//return rep.getSpace();
@@ -2435,13 +2353,11 @@
 		FederateNotExecutionMember,
 		RTIinternalError)
 	{ 
-		DEFINE_REQ_REP( M_Get_Object_Class );
+		M_Get_Object_Class req, rep ;
 
-		req->setObject(rti1516::ObjectInstanceHandleFriend::toCertiHandle(theObject));
-		rep = privateRefs->executeServiceTmpl(req,rep);
-		ObjectClassHandle handle = rti1516::ObjectClassHandleFriend::createRTI1516Handle(rep->getObjectClass());
-		DELETE_REP();
-		return handle;
+		req.setObject(rti1516::ObjectInstanceHandleFriend::toCertiHandle(theObject));
+		privateRefs->executeService(&req, &rep);
+		return rti1516::ObjectClassHandleFriend::createRTI1516Handle(rep.getObjectClass());
 	}
 
 	// 10.17
@@ -2451,11 +2367,10 @@
 		FederateNotExecutionMember,
 		RTIinternalError)
 	{ 
-		DEFINE_REQ_REP( M_Get_Interaction_Space_Handle );
+		M_Get_Interaction_Space_Handle req, rep ;
 
-		req->setInteractionClass(rti1516::InteractionClassHandleFriend::toCertiHandle(theClass));
-		rep = privateRefs->executeServiceTmpl(req,rep);
-		DELETE_REP();
+		req.setInteractionClass(rti1516::InteractionClassHandleFriend::toCertiHandle(theClass));
+		this->privateRefs->executeService(&req, &rep);
 		
 		//JRE TODO: Use space handle to to get the DimensionHandleSet?@!
 		//return rep.getSpace();
@@ -2470,14 +2385,12 @@
 		FederateNotExecutionMember,
 		RTIinternalError)
 	{ 
-		DEFINE_REQ_REP( M_Get_Transportation_Handle );
+		M_Get_Transportation_Handle req, rep ;
 		std::string nameString(transportationName.begin(), transportationName.end());
-		req->setTransportationName(nameString);
-		rep = privateRefs->executeServiceTmpl(req,rep);
+		req.setTransportationName(nameString);
+		privateRefs->executeService(&req, &rep);
 
-		TransportationType tr = rti1516::toRTI1516TransportationType(rep->getTransportation());
-		DELETE_REP();
-		return tr;
+		return rti1516::toRTI1516TransportationType(rep.getTransportation());
 	}
 
 	// 10.19
@@ -2487,16 +2400,15 @@
 		FederateNotExecutionMember,
 		RTIinternalError)
 	{ 
-		DEFINE_REQ_REP( M_Get_Transportation_Name );
+		M_Get_Transportation_Name req, rep ;
 
-		req->setTransportation(rti1516::toCertiTransportationType(transportationType));
-		rep = privateRefs->executeServiceTmpl(req,rep);
+		req.setTransportation(rti1516::toCertiTransportationType(transportationType));
+		privateRefs->executeService(&req, &rep);
 
 		//return hla_strdup(rep.getTransportationName());
-		std::string nameString = rep->getTransportationName();
+		std::string nameString = rep.getTransportationName();
 		std::wstring nameWString(nameString.begin(), nameString.end());
 
-		DELETE_REP();
 		return nameWString;
 	}
 
@@ -2507,15 +2419,13 @@
 		FederateNotExecutionMember,
 		RTIinternalError)
 	{ 
-		DEFINE_REQ_REP( M_Get_Ordering_Handle );
+		M_Get_Ordering_Handle req, rep ;
 
 		std::string nameAsString(orderName.begin(), orderName.end());
-		req->setOrderingName(nameAsString);
-		rep = privateRefs->executeServiceTmpl(req,rep);
+		req.setOrderingName(nameAsString);
+		privateRefs->executeService(&req, &rep);
 		
-		OrderType order = rti1516::toRTI1516OrderType(rep->getOrdering());
-		DELETE_REP();
-		return order;
+		return rti1516::toRTI1516OrderType(rep.getOrdering());
 	}
 
 	// 10.21
@@ -2525,16 +2435,15 @@
 		FederateNotExecutionMember,
 		RTIinternalError)
 	{ 
-		DEFINE_REQ_REP( M_Get_Ordering_Name );
+		M_Get_Ordering_Name req, rep ;
 
-		req->setOrdering(rti1516::toCertiOrderType(orderType));
-		rep = privateRefs->executeServiceTmpl(req,rep);
+		req.setOrdering(rti1516::toCertiOrderType(orderType));
+		privateRefs->executeService(&req, &rep);
 		
 		//return hla_strdup(rep.getOrderingName());
-		std::string nameString = rep->getOrderingName();
+		std::string nameString = rep.getOrderingName();
 		std::wstring nameWString(nameString.begin(), nameString.end());
 
-		DELETE_REP();
 		return nameWString;
 	}
 
@@ -2564,9 +2473,8 @@
 		RestoreInProgress,
 		RTIinternalError)
 	{ 
-		DEFINE_REQ_REP( M_Enable_Class_Relevance_Advisory_Switch );
-		rep = privateRefs->executeServiceTmpl(req,rep);
-		DELETE_REP();
+		M_Enable_Class_Relevance_Advisory_Switch req, rep ;
+		privateRefs->executeService(&req, &rep);
 	}
 
 	// 10.23
@@ -2595,9 +2503,8 @@
 		RestoreInProgress,
 		RTIinternalError)
 	{ 
-		DEFINE_REQ_REP( M_Disable_Class_Relevance_Advisory_Switch );
-		rep = privateRefs->executeServiceTmpl(req,rep);
-		DELETE_REP();
+		M_Disable_Class_Relevance_Advisory_Switch req, rep ;
+		privateRefs->executeService(&req, &rep);
 	}
 
 	// 10.24
@@ -2627,9 +2534,8 @@
 		RestoreInProgress,
 		RTIinternalError)
 	{ 
-		DEFINE_REQ_REP( M_Enable_Attribute_Relevance_Advisory_Switch );
-		rep = privateRefs->executeServiceTmpl(req,rep);
-		DELETE_REP(); 
+		M_Enable_Attribute_Relevance_Advisory_Switch req, rep ;
+		privateRefs->executeService(&req, &rep); 
 	}
 
 	// 10.25
@@ -2659,9 +2565,8 @@
 		RestoreInProgress,
 		RTIinternalError)
 	{ 
-		DEFINE_REQ_REP( M_Disable_Attribute_Relevance_Advisory_Switch );
-		rep = privateRefs->executeServiceTmpl(req,rep);
-		DELETE_REP();
+		M_Disable_Attribute_Relevance_Advisory_Switch req, rep ;
+		privateRefs->executeService(&req, &rep);
 	}
 
 	// 10.26
@@ -2690,9 +2595,8 @@
 		RestoreInProgress,
 		RTIinternalError)
 	{ 
-		DEFINE_REQ_REP( M_Enable_Attribute_Scope_Advisory_Switch );
-		rep = privateRefs->executeServiceTmpl(req,rep);
-		DELETE_REP();
+		M_Enable_Attribute_Scope_Advisory_Switch req, rep ;
+		privateRefs->executeService(&req, &rep);
 	}
 
 	// 10.27
@@ -2721,9 +2625,8 @@
 		RestoreInProgress,
 		RTIinternalError)
 	{ 
-		DEFINE_REQ_REP( M_Disable_Attribute_Scope_Advisory_Switch );
-		rep = privateRefs->executeServiceTmpl(req,rep);
-		DELETE_REP();
+		M_Disable_Attribute_Scope_Advisory_Switch req, rep ;
+		privateRefs->executeService(&req, &rep);
 	}
 
 	// 10.28
@@ -2752,9 +2655,8 @@
 		RestoreInProgress,
 		RTIinternalError)
 	{ 
-		DEFINE_REQ_REP( M_Enable_Interaction_Relevance_Advisory_Switch );
-		rep = privateRefs->executeServiceTmpl(req,rep);
-		DELETE_REP();
+		M_Enable_Interaction_Relevance_Advisory_Switch req, rep ;
+		privateRefs->executeService(&req, &rep);
 	}
 
 	// 10.29
@@ -2783,9 +2685,8 @@
 		RestoreInProgress,
 		RTIinternalError)
 	{ 
-		DEFINE_REQ_REP( M_Disable_Interaction_Relevance_Advisory_Switch );
-		rep = privateRefs->executeServiceTmpl(req,rep);
-		DELETE_REP(); 
+		M_Disable_Interaction_Relevance_Advisory_Switch req, rep ;
+		privateRefs->executeService(&req, &rep); 
 	}
 
 	// 10.30
diff -U 3 -H -d -r -N -x '*.kdev' -x '.svn*' -x 'CVS*' -- patched/libRTI/RTI1516ambassador.h origin/libRTI/RTI1516ambassador.h
--- patched/libRTI/RTI1516ambassador.h	2012-01-16 14:08:55.000000000 +0400
+++ origin/libRTI/RTI1516ambassador.h	2010-05-31 13:33:25.000000000 +0400
@@ -3,16 +3,10 @@
 #ifndef RTI_RTI1516ambassador_h
 #define RTI_RTI1516ambassador_h
 
-#include "config.h"
 #include <RTI/RTIambassador.h>
 #include <RTI/RTIambassadorFactory.h>
 #include "RTI1516ambPrivateRefs.h"
 
-#ifdef RTIA_USE_THREAD
-// path to these files is actually defined in CMakeLists.txt
-#include "../libRTIA/librtia_buf.hpp"
-#include "../RTIA/RTIA.hh"
-#endif
 
 namespace rti1516
 {
@@ -26,22 +20,17 @@
 	private:
 		RTI1516ambPrivateRefs* privateRefs ;
 
-#ifdef RTIA_USE_THREAD
-		certi::rtia::RTIA rtia1516;
-		LibRTIABufSet bufSet;
-#endif
-
 		// Helper functions
-		template<typename MSG>
-		MSG* assignAHSAndExecuteService(const rti1516::AttributeHandleSet &AHS, MSG *req, MSG *rep  );
-		template<typename MSG>
-		MSG* assignPHVMAndExecuteService(const rti1516::ParameterHandleValueMap &PHVM, MSG *req, MSG *rep );
-		template<typename MSG>
-		MSG* assignAHVMAndExecuteService(const rti1516::AttributeHandleValueMap &AHVM, MSG *req, MSG *rep );
+		template<typename T> void
+			assignAHSAndExecuteService(const rti1516::AttributeHandleSet &AHS, T &req, T &rep);
+		template<typename T> void
+			assignPHVMAndExecuteService(const rti1516::ParameterHandleValueMap &PHVM, T &req, T &rep);
+		template<typename T> void 
+			assignAHVMAndExecuteService(const rti1516::AttributeHandleValueMap &AHVM, T &req, T &rep);
 		// Helper function for CallBacks
 		bool __tick_kernel(bool, TickTime, TickTime)
 			throw (SpecifiedSaveLabelDoesNotExist, RTIinternalError);
-		
+
 	protected:
 		RTI1516ambassador()
 			throw ();
diff -U 3 -H -d -r -N -x '*.kdev' -x '.svn*' -x 'CVS*' -- patched/libRTI/RTI1516ambassadorFactory.cpp origin/libRTI/RTI1516ambassadorFactory.cpp
--- patched/libRTI/RTI1516ambassadorFactory.cpp	2012-01-19 14:57:25.000000000 +0400
+++ origin/libRTI/RTI1516ambassadorFactory.cpp	2011-10-27 11:59:51.000000000 +0400
@@ -45,17 +45,12 @@
 	PrettyDebug::setFederateName( "LibRTI::UnjoinedFederate" );
 	std::wstringstream msg;
 
-#ifdef RTIA_USE_THREAD
-	p_ambassador->privateRefs = new RTI1516ambPrivateRefs( &p_ambassador->bufSet );
-#else //RTIA_USE_THREAD
 	p_ambassador->privateRefs = new RTI1516ambPrivateRefs();
-#endif //RTIA_USE_THREAD
-	// WARNING: not sure about this
-	p_ambassador->privateRefs->is_reentrant = false ;
-	
-#ifndef RTIA_USE_THREAD
+
 	p_ambassador->privateRefs->socketUn = new SocketUN(stIgnoreSignal);
 
+	p_ambassador->privateRefs->is_reentrant = false ;
+
 	std::vector<std::string> rtiaList;
 	const char* env = getenv("CERTI_RTIA");
 	if (env && strlen(env))
@@ -88,7 +83,6 @@
 	si.cb = sizeof(si);
 	ZeroMemory( &pi, sizeof(pi) );
 
-// TODO: cope the relation between RTIA_CONSOLE_SHOW & RTIA_USE_THREAD
 #ifndef RTIA_CONSOLE_SHOW
 	/*
 	 * Avoid displaying console window
@@ -151,7 +145,7 @@
 	closesocket(newPipeFd);
 #endif
 
-#else // _WIN32
+#else
 
 	sigset_t nset, oset;
 	// temporarily block termination signals
@@ -220,26 +214,12 @@
 	}
 #endif
 
-#else // RTIA_USE_THREAD
-	p_ambassador->rtia1516.launchRTIAthread( &p_ambassador->bufSet );
-#endif // RTIA_USE_THREAD
-
-#ifdef RTIA_USE_THREAD
-	certi::M_Open_Connexion *req = new certi::M_Open_Connexion, *rep = NULL;
-#else // RTIA_USE_THREAD
-	certi::M_Open_Connexion local_req, *req = &local_req, local_rep, *rep = &local_rep;
-#endif // RTIA_USE_THREAD
-
-	
-	req->setVersionMajor(CERTI_Message::versionMajor);
-	req->setVersionMinor(CERTI_Message::versionMinor);
+	certi::M_Open_Connexion req, rep ;
+	req.setVersionMajor(CERTI_Message::versionMajor);
+	req.setVersionMinor(CERTI_Message::versionMinor);
 
 	G1516.Out(pdGendoc,"        ====>executeService OPEN_CONNEXION");
-	p_ambassador->privateRefs->executeService( req, rep );
-
-#ifdef RTIA_USE_THREAD
-	delete rep;
-#endif // RTIA_USE_THREAD
+	p_ambassador->privateRefs->executeService(&req, &rep);
 
 	G1516.Out(pdGendoc,"exit  RTIambassador::RTIambassador");
 
